# coding: utf-8

"""
    Contabo API


    The version of the OpenAPI document: 1.0.0
    Contact: support@contabo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class AssignmentResponse(BaseModel):
    """
    AssignmentResponse
    """ # noqa: E501
    tenant_id: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Your customer tenant id", alias="tenantId")
    customer_id: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Your customer number", alias="customerId")
    tag_id: StrictInt = Field(description="The identifier of the tag.", alias="tagId")
    tag_name: Annotated[str, Field(min_length=1, strict=True, max_length=255)] = Field(description="Tag's name", alias="tagName")
    resource_type: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Resource type. Resource type is one of `instance|image|object-storage`.", alias="resourceType")
    resource_id: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Resource id", alias="resourceId")
    resource_name: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Resource name", alias="resourceName")
    __properties: ClassVar[List[str]] = ["tenantId", "customerId", "tagId", "tagName", "resourceType", "resourceId", "resourceName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AssignmentResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AssignmentResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tenantId": obj.get("tenantId"),
            "customerId": obj.get("customerId"),
            "tagId": obj.get("tagId"),
            "tagName": obj.get("tagName"),
            "resourceType": obj.get("resourceType"),
            "resourceId": obj.get("resourceId"),
            "resourceName": obj.get("resourceName")
        })
        return _obj


