# coding: utf-8

"""
    Contabo API


    The version of the OpenAPI document: 1.0.0
    Contact: support@contabo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CreateUserRequest(BaseModel):
    """
    CreateUserRequest
    """ # noqa: E501
    first_name: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=255)]] = Field(default=None, description="The name of the user. Names may contain letters, numbers, colons, dashes, and underscores. There is a limit of 255 characters per user.", alias="firstName")
    last_name: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=255)]] = Field(default=None, description="The last name of the user. Users may contain letters, numbers, colons, dashes, and underscores. There is a limit of 255 characters per user.", alias="lastName")
    email: Annotated[str, Field(min_length=1, strict=True, max_length=255)] = Field(description="The email of the user to which activation and forgot password links are being sent to. There is a limit of 255 characters per email.")
    enabled: StrictBool = Field(description="If user is not enabled, he can't login and thus use services any longer.")
    totp: StrictBool = Field(description="Enable or disable two-factor authentication (2FA) via time based OTP.")
    locale: StrictStr = Field(description="The locale of the user. This can be `de-DE`, `de`, `en-US`, `en`")
    roles: Optional[List[StrictInt]] = Field(default=None, description="The roles as list of `roleId`s of the user.")
    __properties: ClassVar[List[str]] = ["firstName", "lastName", "email", "enabled", "totp", "locale", "roles"]

    @field_validator('locale')
    def locale_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['de-DE', 'de', 'en-US', 'en']):
            raise ValueError("must be one of enum values ('de-DE', 'de', 'en-US', 'en')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateUserRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateUserRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "firstName": obj.get("firstName"),
            "lastName": obj.get("lastName"),
            "email": obj.get("email"),
            "enabled": obj.get("enabled"),
            "totp": obj.get("totp"),
            "locale": obj.get("locale"),
            "roles": obj.get("roles")
        })
        return _obj


