# coding: utf-8

"""
    Contabo API


    The version of the OpenAPI document: 1.0.0
    Contact: support@contabo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class DataCenterResponse(BaseModel):
    """
    DataCenterResponse
    """ # noqa: E501
    name: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Name of the data center")
    slug: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Slug of the data center")
    capabilities: List[StrictStr]
    s3_url: Annotated[str, Field(min_length=1, strict=True)] = Field(description="S3 URL of the data center", alias="s3Url")
    region_name: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Name of the region", alias="regionName")
    region_slug: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Slug of the region", alias="regionSlug")
    tenant_id: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Your customer tenant id", alias="tenantId")
    customer_id: Annotated[str, Field(min_length=1, strict=True)] = Field(description="Your customer number", alias="customerId")
    __properties: ClassVar[List[str]] = ["name", "slug", "capabilities", "s3Url", "regionName", "regionSlug", "tenantId", "customerId"]

    @field_validator('capabilities')
    def capabilities_validate_enum(cls, value):
        """Validates the enum"""
        for i in value:
            if i not in set(['VPS', 'VDS', 'Object-Storage', 'Private-Networking']):
                raise ValueError("each list item must be one of ('VPS', 'VDS', 'Object-Storage', 'Private-Networking')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataCenterResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataCenterResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "slug": obj.get("slug"),
            "capabilities": obj.get("capabilities"),
            "s3Url": obj.get("s3Url"),
            "regionName": obj.get("regionName"),
            "regionSlug": obj.get("regionSlug"),
            "tenantId": obj.get("tenantId"),
            "customerId": obj.get("customerId")
        })
        return _obj


